<?php

class wpForoAttachmentsTools{
	public function __construct(){
		add_filter('wpforo_body_text_filter', array(&$this, 'do_shortcodes'));
		add_filter('wpforo_body_text_filter', array(&$this, 'do_default_attachs'));
		add_action('wp_ajax_wpforoattach_load_ajax_function', array(&$this, 'init_uploader_class'));
		add_action('wp_ajax_wpforoattach_file_upload_hook', array(&$this, 'file_upload_hook'));
	}
	
	public function get_file_type($filename){
		$ext = strtolower( pathinfo($filename, PATHINFO_EXTENSION) );
		
		if($ext == 'pdf') return 'pdf';
		if($ext == 'doc' || $ext == 'docx' || $ext == 'odm' || $ext == 'odt' || $ext == 'ott') return 'word';
		if($ext == 'zip' || $ext == 'gz' || $ext == 'bz' || $ext == 'bz2' || $ext == 'tar' || $ext == 'tgz' || $ext == '7z' || $ext == 'jar' || $ext == 'rar' || $ext == 'iso') return 'archive';
		if($ext == 'csv' || $ext == 'xlsx' || $ext == 'xls' || $ext == 'xlsb' || $ext == 'xlsm' || $ext == 'xlt' || $ext == 'xltm' || $ext == 'ots' || $ext == 'ods' || $ext == 'stc' || $ext == 'sxc') return 'excel';
		if($ext == 'xml' || $ext == 'html' || $ext == 'js' || $ext == 'php' || $ext == 'sql' || $ext == 'css' || $ext == 'sh' || $ext == 'csh' || $ext == 'json' || $ext == 'tcl' || $ext == 'bat' || $ext == 'as' || $ext == 'cmd') return 'code';
		if($ext == 'ppt' || $ext == 'pptx' || $ext == 'otp' || $ext == 'odp' || $ext == 'pot' || $ext == 'pps' || $ext == 'shw' || $ext == 'sti' || $ext == 'sxi' || $ext == 'thmx') return 'powerpoint';
		
		if($ext == 'jpg' || $ext == 'jpeg' || $ext == 'png' || $ext == 'gif' || $ext == 'bmp' || $ext == 'tiff' || $ext == 'tif' || $ext == 'ico') return 'picture';
		if($ext == 'mp4' || $ext == 'flv' || $ext == 'mov' || $ext == 'mkv' || $ext == 'vob' || $ext == 'mpg' || $ext == 'mpeg' || $ext == 'mpe' || $ext == '3gp' || $ext == 'avi' || $ext == 'wmv') return 'video';
		if($ext == 'mp3' || $ext == 'wma' || $ext == 'wav' || $ext == 'amr' || $ext == 'mp2' || $ext == 'aac') return 'audio';
		if($ext == 'txt' || $ext == 'asc') return 'text';
		
		return 'file';
	}

	public function get_file_fa_ico($filename){
		$filetype = $this->get_file_type($filename);
		$filetype = $filetype != 'file' ? $filetype . '-' : '';
		return '<i class="fa fa-file-'.$filetype.'o fa-5x wpfa-file-icon"></i>';
	}

    public function strip_not_allowed_filetypes($accepted_file_types = ''){
        if(!$accepted_file_types) $accepted_file_types = WPF_ATTACH()->options['accepted_file_types'];

        if( !WPF()->perm->usergroup_can( 'em' ) && WPF()->member->current_user_is_new() ){
            $limited_file_ext = '';
            if(!empty(WPF()->tools_antispam['limited_file_ext']))
                $limited_file_ext = WPF()->tools_antispam['limited_file_ext'];

            $accepted_file_types = array_filter( array_map('trim', explode('|', $accepted_file_types)) );
            $limited_file_ext    = array_filter( array_map('trim', explode('|', $limited_file_ext)) );
            $accepted_file_types = array_diff( (array) $accepted_file_types, (array) $limited_file_ext);
            $accepted_file_types = implode('|', $accepted_file_types);
        }

        return $accepted_file_types;
    }

	public function do_shortcodes($text){
		if(preg_match_all('#\[attach(?:[^\[\]]+?title=[\'\"]([^\'\"]+)[\'\"])?[^\[\]]*?\](.*?)\[\/attach\]#isu', $text, $shortcodes, PREG_SET_ORDER)){
			foreach($shortcodes as $shortcode){

			    $alt_title = '';
				$attachids = '';
				$expld_attachids = explode(',', $shortcode[2]);
				if(!empty($expld_attachids)){
                    $shortcode_title = false;
				    if( !empty($shortcode[1]) ){
                        $alt_title = trim($shortcode[1]);
                        $shortcode_title = true;
                    }
					
					foreach($expld_attachids as $expld_attachid){
						$expld_attachid = trim($expld_attachid);
						if(is_numeric($expld_attachid)) $attachids .= $expld_attachid . ',';
					}
					
					$attachids = trim( trim($attachids), ',' );
					$attachs = WPF_ATTACH()->get_attachs( array('include' => $attachids, 'orderby' => 'FIELD(`attachid`,'.$attachids.')') );
					$attach_html = '';
					if(!empty($attachs)){
						
						if(WPF()->perm->forum_can('va')){
							foreach($attachs as $key => $attach){
								extract($attach);

								if( !$shortcode_title || ($shortcode_title && $key) ) $alt_title = str_replace( array('-', '_'), ' ', pathinfo($filename, PATHINFO_FILENAME) );
								$attr = 'alt="'.$alt_title.'" title="'.$alt_title.'"';
								$link_attr = 'title="'.$alt_title.'"';

								$fileurl = preg_replace('#^https?\:#is', '', $fileurl);
								
								$upload_array = wp_upload_dir();
								$filedir = preg_replace('#^https?\:#is', '', str_replace( preg_replace('#^https?\:#is', '', $upload_array['baseurl']), $upload_array['basedir'], $fileurl ) );
								$filedir = str_replace( basename($filedir), urldecode( basename($filedir) ), $filedir );
								if(file_exists($filedir)){
									$w = (int)WPF_ATTACH()->options['thumbnail_width'];
									$h = (int)WPF_ATTACH()->options['thumbnail_height'];
									if(strpos($mime, 'image/') !== FALSE){ 
										if( isset(WPF_ATTACH()->options['image_caption']) && WPF_ATTACH()->options['image_caption'] ){
											$attach_html .= '<div class="wpfa-item wpfa-img-caption"><a href="' . $fileurl . '" data-gallery="#wpf-content-blueimp-gallery" ' . $link_attr . '><img src="' . str_replace( basename($fileurl), 'thumbnail/'.basename($fileurl), $fileurl )  . '" style="max-width:'.$w.'px; max-height:'.$h.'px;"/></a><div class="wpfa-info" '.$attr.'>' . urldecode( basename($filename) ) . '</div></div>';
										}else{
											if( isset(WPF_ATTACH()->options['boxed']) && WPF_ATTACH()->options['boxed'] ){
												$attach_html .= '<div class="wpfa-item wpfa-img-boxed" style="min-width:'.$w.'px;min-height:'.$h.'px;"><a href="' . $fileurl . '" data-gallery="#wpf-content-blueimp-gallery"><img src="' . str_replace( basename($fileurl), 'thumbnail/'.basename($fileurl), $fileurl )  . '" style="max-width:'.$w.'px; max-height:'.$h.'px;"  '.$attr.'/></a></div>';
											}
											else{
												$attach_html .= '<div class="wpfa-item wpfa-img"><a href="' . $fileurl . '" data-gallery="#wpf-content-blueimp-gallery" ' . $link_attr . '><img src="' . str_replace( basename($fileurl), 'thumbnail/'.basename($fileurl), $fileurl )  . '" style="max-width:'.$w.'px; max-height:'.$h.'px;"  '.$attr.'/></a></div>';
											}
										}
									}elseif(strpos($mime, 'video/') !== FALSE){
										$attach_html .= '<div class="wpfa-item wpfa-video"><video src="' . $fileurl . '" controls  '.$attr.'></video></div>';
									}elseif(strpos($mime, 'audio/') !== FALSE){
										$attach_html .= '<div class="wpfa-item wpfa-audio"><audio src="' . $fileurl . '" controls  '.$attr.'></audio></div>';
									}else{ 
										$attach_html .= '<div class="wpfa-item wpfa-file"><a href="' . $fileurl . '" target="_blank" download="'.$filename.'" ' . $link_attr . '>' . $this->get_file_fa_ico($filename) . '<span>' . urldecode( basename($filename) ) . '</span></a></div>';
									}
								}
								
							}
						}else{
							foreach($attachs as $attach){
								extract($attach, EXTR_OVERWRITE);
								
								$fileurl = preg_replace('#^https?\:#is', '', $fileurl);
								
								$upload_array = wp_upload_dir();
								$filedir = preg_replace('#^https?\:#is', '', str_replace( preg_replace('#^https?\:#is', '', $upload_array['baseurl']), $upload_array['basedir'], $fileurl ) );
								$filedir = str_replace( basename($filedir), urldecode( basename($filedir) ), $filedir );
								
								if(file_exists($filedir)){
									$attach_html .= '<br/><div class="wpfa-item wpfa-file" style="border: 1px dotted #bbb; padding: 5px 10px; font-size: 13px; margin: 5px 2px;"><a class="attach_cant_view" style="cursor:pointer;"><span style="color:#666;">' . wpforo_phrase('Attachment', FALSE) . ':</span> ' . urldecode( basename($filename) ) . '</a></div>';
								}
								
							}
						}
						
					}
					
					if($attach_html) $attach_html .= '<br/>';
					$text = str_replace($shortcode[0], $attach_html, $text);
					
				}
			}
		}
		
		return $text;
	}

	public function do_default_attachs($text){
		if( preg_match_all('#<a[^<>]*class=[\'"]wpforo-default-attachment[\'"][^<>]*href=[\'"]([^\'"]+)[\'"][^<>]*>[\r\n\t\s\0]*(?:<i[^<>]*>[\r\n\t\s\0]*</i>[\r\n\t\s\0]*)?([^<>]*)</a>#isu', $text, $matches, PREG_SET_ORDER) ){
			foreach( $matches as $match ){
				$attach_html = '';
				$fileurl = preg_replace('#^https?\:#is', '', $match[1]);
				$filename = $match[2];
				$filetype = $this->get_file_type($fileurl);

                $alt_title = str_replace( array('-', '_'), ' ', pathinfo($filename, PATHINFO_FILENAME) );
                $attr = 'alt="'.$alt_title.'" title="'.$alt_title.'"';
				
				$upload_array = wp_upload_dir();
				$filedir = preg_replace('#^https?\:#is', '', str_replace( preg_replace('#^https?\:#is', '', $upload_array['baseurl']), $upload_array['basedir'], $fileurl ) );
				$filedir = str_replace( basename($filedir), urldecode( basename($filedir) ), $filedir );
				
				if(file_exists($filedir)){
					if(WPF()->perm->forum_can('va')){
						if($filetype == 'picture'){ 
							if( isset(WPF_ATTACH()->options['image_caption']) && WPF_ATTACH()->options['image_caption'] ){
								$attach_html .= '<br/><div class="wpfa-item wpfa-img"><a href="' . $fileurl . '" data-gallery="#wpf-content-blueimp-gallery"><img src="' . $fileurl  . '" '.$attr.'/></a><div class="wpfa-info">' . urldecode( basename($filename) ) . '</div></div>';
							}else{
								$attach_html .= '<br/><a href="' . $fileurl . '" data-gallery="#wpf-content-blueimp-gallery"><img src="' . $fileurl  . '"  '.$attr.'/></a>';
							}
						}elseif($filetype == 'video'){
							$attach_html .= '<br/><video src="' . $fileurl . '" controls  '.$attr.'></video>';
						}elseif($filetype == 'audio'){
							$attach_html .= '<br/><audio src="' . $fileurl . '" controls  '.$attr.'></audio>';
						}else{ 
							$attach_html .= '<br/><div class="wpfa-item wpfa-file"><a href="' . $fileurl . '" target="_blank" download="'.$filename.'"  '.$attr.'>' . $this->get_file_fa_ico($fileurl) . urldecode( basename($filename) ) . '</a><div class="wpfa-info"></div></div>';
						}
					}else{
						$attach_html .= '<br/><div class="wpfa-item wpfa-file"><a class="attach_cant_view" style="cursor:pointer;"><span style="color:#666;">' . wpforo_phrase('Attachment', FALSE) . ':</span> ' . urldecode( basename($filename) ) . '</a></div>';
					}
				}
				
				if($attach_html) $attach_html .= '<br/>';
				$text = str_replace($match[0], $attach_html, $text);
			}
		}
		
		return $text;
	}
	

	public function init_uploader_class(){
		/* Include the upload handler */
		require_once( WPFOROATTACH_DIR . '/wpf-third-party/file-uploader/UploadHandler.php');
		require_once( WPFOROATTACH_DIR . '/includes/class.wpForoAttachUploadHandler.php');
		
		$upload_array = wp_upload_dir();
	    $options = array(
	        'script_url' => admin_url('admin-ajax.php'),
	        'delete_type' => 'POST',
	        'upload_dir' => $upload_array['basedir'].'/wpforo/attachments/'.WPF()->current_userid.'/',
	        'upload_url' => preg_replace('#^https?\:#is', '', $upload_array['baseurl']).'/wpforo/attachments/'.WPF()->current_userid.'/',
	        'inline_file_types' => '#\.(' . WPF_ATTACH()->options['accepted_file_types'] . ')$#isu',
	        'accept_file_types' => '#\.(' . WPF_ATTACH()->options['accepted_file_types'] . ')$#isu',
	        'max_file_size' => ( 1048576 * WPF_ATTACH()->options['maximum_file_size'] ),
	        'image_file_types' => '#\.(' . WPF_ATTACH()->options['accepted_file_types'] . ')$#isu',
	        'image_versions' => array(
	            // The empty image version key defines options for the original image:
	            '' => array(
	                // Automatically rotate images based on EXIF meta data:
	                'auto_orient' => true
	            ),
	            'thumbnail' => array(
	                'max_width' => WPF_ATTACH()->options['thumbnail_width'],
	                'max_height' => WPF_ATTACH()->options['thumbnail_height']
	            )
	        )
	    );
	    
	    $error_messages = array(
	        1 => wpforo_attach_phrase('The uploaded file exceeds the upload_max_filesize directive in php.ini', FALSE),
	        2 => wpforo_attach_phrase('The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form', FALSE),
	        3 => wpforo_attach_phrase('The uploaded file was only partially uploaded', FALSE),
	        4 => wpforo_attach_phrase('No file was uploaded', FALSE),
	        6 => wpforo_attach_phrase('Missing a temporary folder', FALSE),
	        7 => wpforo_attach_phrase('Failed to write file to disk', FALSE),
	        8 => wpforo_attach_phrase('A PHP extension stopped the file upload', FALSE),
	        'post_max_size' => wpforo_attach_phrase('The uploaded file exceeds the post_max_size directive in php.ini', FALSE),
	        'max_file_size' => wpforo_attach_phrase('File is too big', FALSE),
	        'min_file_size' => wpforo_attach_phrase('File is too small', FALSE),
	        'accept_file_types' => wpforo_attach_phrase('Filetype not allowed', FALSE),
	        'max_number_of_files' => wpforo_attach_phrase('Maximum number of files exceeded', FALSE),
	        'max_width' => wpforo_attach_phrase('Image exceeds maximum width', FALSE),
	        'min_width' => wpforo_attach_phrase('Image requires a minimum width', FALSE),
	        'max_height' => wpforo_attach_phrase('Image exceeds maximum height', FALSE),
	        'min_height' => wpforo_attach_phrase('Image requires a minimum height', FALSE),
	        'abort' => wpforo_attach_phrase('File upload aborted', FALSE),
	        'image_resize' => wpforo_attach_phrase('Failed to resize image', FALSE)
	    );
		
		new wpForoAttachUploadHandler($options, TRUE, $error_messages);
		die();
	}
	/* Hook on ajax call */
	

	/* Block of code that need to be printed to the form*/
	public function file_upload_hook() {
		WPF_ATTACH()->css_js_ajaxload();
		?>
		<script id="wpfa-template-upload" type="text/x-tmpl">
			{%
				var wpfaOptions = <?php echo json_encode(WPF_ATTACH()->options) ?>;
				function wpfa_phrase(phrase_key){
					phrase_key = phrase_key.toLowerCase();
					var wpfaPhrases = <?php echo json_encode(WPF_ATTACH()->phrases) ?>;
					if( wpfaPhrases[phrase_key] !== undefined ) phrase_key = wpfaPhrases[phrase_key];
					return phrase_key;
				}
			%}
			{% for (var i=0, file; file=o.files[i]; i++) { %}
				{%
					var wpfa_file_is_allowed = true;
					var wpfa_file_allow_error = '';

					if( file.size > ( 1048576 * wpfaOptions['maximum_file_size'] ) ){
						wpfa_file_is_allowed = false;
						wpfa_file_allow_error = wpfa_phrase('Error: File is too big. Allowed size is: %s').replace('%s', wpfaOptions['maximum_file_size'] + 'MB');
					}else if( file.size > ( 1048576 * parseInt(wpfaOptions['server_upload_max_filesize']) ) ){
						wpfa_file_is_allowed = false;
						wpfa_file_allow_error = wpfa_phrase('Error: File is too big. server_upload_max_filesize is: %s').replace('%s', wpfaOptions['server_upload_max_filesize'] + 'MB');
					}else if( file.size > ( 1048576 * parseInt(wpfaOptions['server_post_max_size']) ) ){
						wpfa_file_is_allowed = false;
						wpfa_file_allow_error = wpfa_phrase('Error: File is too big. server_post_max_size is: %s').replace('%s', wpfaOptions['server_post_max_size'] + 'MB');
					}

					var FileTypesRegex = new RegExp('\.('+wpfaOptions['accepted_file_types']+')$', 'i');
					if(!FileTypesRegex.test(file.name)){
					    wpfa_file_is_allowed = false;
					    wpfa_file_allow_error = wpfa_phrase('Error: Filetype not allowed');
					}

					var wpf_type = wpforo_get_file_type(file.name);
					var wpf_file_fa_ico = wpf_type != 'file' ? wpf_type + '-' : '';
				%}
				{% if(wpfa_file_is_allowed) { %}
				    <div class="wpfa-dialog-item-row wpfa-template-upload">
				    	<div class="wpfa-dialog-item-col wpfa-item-col-id wpfa-show-for-large">
				    		<i class="id"><strong>__</strong></i>
				    	</div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-preview">
				        	{% if(wpf_type == 'picture' || wpf_type == 'video' || wpf_type == 'audio') { %}
				            	<span class="wpfa-preview wpfa-show-for-large"></span>
				            	<i class="wpfa-hide-for-large fa fa-file-{%=wpf_file_fa_ico%}o fa-3x"></i>
				            {% }else{ %}
			            		<i class="fa fa-file-{%=wpf_file_fa_ico%}o fa-3x"></i>
			            	{% } %}
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-filename">
				            <span class="wpfa-name" style="overflow-x:hidden;">{%=file.name%}</span>
				            <strong class="wpfa-error"></strong>
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-filesize">
				            <span class="wpfa-size">( {%=o.formatFileSize(file.size)%} )</span>
				            <div class="wpfa-progress"></div>
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-action-buttons">
				            {% if (!i && !o.options.autoUpload) { %}
				                <button type="button" class="wpfa-start-upload wpfa-start wpfa-button wpfa-button-start" disabled>
				                	<span class="wpfa-button-icon"><i class="fa fa-upload"></i></span>
				                	<span class="wpfa-button-text wpfa-show-for-large"><?php wpforo_attach_phrase('Start') ?></span>
				                </button>
				            {% } %}
				            {% if (!i) { %}
				                <button type="button" class="wpfa-cancel wpfa-button wpfa-button-cancel">
				                    <span class="wpfa-button-icon"><i class="fa fa-ban"></i></span>
				                	<span class="wpfa-button-text wpfa-show-for-large"><?php wpforo_attach_phrase('Cancel') ?></span>
				                </button>
				            {% } %}
				        </div>
				    </div>
				{% }else{ %}
					<div class="wpfa-dialog-item-row wpfa-file-not-allow" style="background-color: bisque;">
				    	<div class="wpfa-dialog-item-col wpfa-item-col-id wpfa-show-for-large">
				    		<i class="id"><strong>__</strong></i>
				    	</div>
				    	<div class="wpfa-dialog-item-col wpfa-item-col-preview">
				        	{% if(wpf_type == 'picture' || wpf_type == 'video' || wpf_type == 'audio') { %}
				            	<span class="wpfa-preview wpfa-show-for-large"></span>
				            {% }else{ %}
			            		<i class="wpfa-hide-for-large fa fa-file-{%=wpf_file_fa_ico%}o fa-3x"></i>
			            	{% } %}
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-filename wpfa-show-for-large">
				            <span class="name" style="overflow-x:hidden;" title="{%=file.name%} ( {%=o.formatFileSize(file.size)%} )">{%=file.name%}</span>
				            ( <span class="size">{%=o.formatFileSize(file.size)%}</span> )
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-error">
				        	<span class="wpfa-error"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i></span>
				        	<strong class="wpfa-error">{%=wpfa_file_allow_error%}</strong>
				        </div>
				        <div class="wpfa-dialog-item-col wpfa-item-col-action-buttons">
			                <strong class="wpfa-error wpfa-close-error" style="cursor:pointer;"><i class="fa fa-times fa-2x" aria-hidden="true" title="<?php wpforo_attach_phrase('close') ?>"></i></strong>
				        </div>
				    </div>
				{% } %}

			{% } %}
		</script>
		<script id="wpfa-template-download" type="text/x-tmpl">
			{% var wpfaOptions = <?php echo json_encode(WPF_ATTACH()->options) ?>; %}
			{% for (var i=0, file; file=o.files[i]; i++) { %}
			    <div class="wpfa-dialog-item-row wpfa-template-download" {% if (file.error) { %} style="background-color: bisque;" {% } %}>
			        <label for="{%=file.id||''%}"></label>
			    	<div class="wpfa-dialog-item-col wpfa-item-col-id wpfa-show-for-large">
			    		<i id="attach{%=file.id||''%}" class="id"><strong><label for="{%=file.id||''%}">{%=file.id||''%}</label></strong></i>
			    	</div>
			        <div class="wpfa-dialog-item-col wpfa-item-col-preview">
			            <span class="wpfa-preview">
			            	{% if (!file.error) { %}
				                {% if (file.thumbnailUrl) { %}
				                    <a href="{%=file.url%}" title="{%=file.filename%}" download="{%=file.filename%}" data-gallery><img src="{%=file.thumbnailUrl%}"></a>
				                {% }else if(file.wpf_type == 'video') { %}
				                	<video class="wpfa-show-for-large" src="{%=file.url%}" controls><i class="fa {%=file.wpf_file_fa_ico%} fa-3x"></i>}</video>
				                	<a class="wpfa-hide-for-large" href="{%=file.url%}" title="{%=file.filename%}" download="{%=file.filename%}" {%=file.thumbnailUrl?'data-gallery':''%}>
				                		<i class="fa fa-file-{%=file.wpf_file_fa_ico%}o fa-3x"></i>
				                	</a>
				                {% }else if(file.wpf_type == 'audio') { %}
				                	<audio class="wpfa-show-for-large" src="{%=file.url%}" controls><i class="fa {%=file.wpf_file_fa_ico%} fa-3x"></i></audio>
				                	<a class="wpfa-hide-for-large" href="{%=file.url%}" title="{%=file.filename%}" download="{%=file.filename%}" {%=file.thumbnailUrl?'data-gallery':''%}>
				                		<i class="fa fa-file-{%=file.wpf_file_fa_ico%}o fa-3x"></i>
				                	</a>
				                {% }else { %}
				                	<a href="{%=file.url%}" title="{%=file.filename%}" download="{%=file.filename%}" {%=file.thumbnailUrl?'data-gallery':''%}>
				                		<i class="fa fa-file-{%=file.wpf_file_fa_ico%}o fa-3x"></i>
				                	</a>
				                {% } %}
				            {% }else{ %}
				                <span class="wpfa-error"><i class="fa fa-exclamation-triangle fa-3x" aria-hidden="true"></i></span>
				            {% } %}
			            </span>
			        </div>
			        <div class="wpfa-dialog-item-col wpfa-item-col-filename">
			        	{% if (!file.error) { %}
			                <a href="{%=file.url%}" title="{%=file.filename%}" download="{%=file.filename%}" {%=file.thumbnailUrl?'data-gallery':''%}>{%=file.filename%}</a>
			            {% }else{ %}
			                <span class="wpfa-error">Error</span> {%=file.error%}
			            {% } %}
			        </div>
			        <div class="wpfa-dialog-item-col wpfa-item-col-filesize wpfa-show-for-large">
			        	{% if (!file.error) { %}
			            	<span class="size"><label for="{%=file.id||''%}">{%=o.formatFileSize(file.size)%}</label></span>
			            {% } %}
			        </div>
			        <div class="wpfa-dialog-item-col wpfa-item-col-action-buttons">
			        	{% if (!file.error) { %}
			        		{% if(wpfaOptions['disable_delete'] != 1){ %}
			        			<button type="button" class="wpfa-delete wpfa-button wpfa-button-delete" data-type="{%=file.deleteType%}" data-url="{%=file.deleteUrl%}&action=wpforoattach_load_ajax_function"{% if (file.deleteWithCredentials) { %} data-xhr-fields='{"withCredentials":true}'{% } %}>
			        			    <span class="wpfa-button-icon"><i class="fa fa-trash"></i></span>
			        			    <span class="wpfa-button-text wpfa-show-for-large"><?php wpforo_attach_phrase('Delete') ?></span>
			        			</button>
			        		{% } %}
			        	{% } %}
			        </div>
					<div class="wpfa-dialog-item-col wpfa-item-col-checkbox">
						{% if (!file.error) { %}
			            	<input id="{%=file.id||''%}" type="checkbox" name="delete" value="1" class="wpfa-toggle" {% if( file.wpf_is_new ) { %} checked {% } %}/>
			            {% } %}
			    	</div>
			    </div>
			{% } %}
		</script>
		<script type="text/javascript">
			jQuery(function () {
			    'use strict';
			    jQuery('#wpfa_fileupload').fileupload({
			        url: '<?php echo admin_url('admin-ajax.php') ?>'
			    });
			    jQuery('#wpfa_fileupload').fileupload(
			        'option',
			        'redirect',
			        window.location.href.replace(
			            /\/[^\/]*$/,
						<?php
						$absoluteurl = str_replace( home_url(), '', WPFOROATTACH_URL );
						print( "'" . $absoluteurl . "/wpf-third-party/file-uploader/cors/result.html?%s'" );
						?>
			        )
			    );
				if(jQuery('#wpfa_fileupload')) {
			        jQuery('#wpfa_fileupload').addClass('wpfa-fileupload-processing');
			        jQuery.ajax({
			            url: jQuery('#wpfa_fileupload').fileupload('option', 'url'),
						data : {action: "wpforoattach_load_ajax_function"},
						acceptFileTypes: /(\.|\/)(<?php print(WPF_ATTACH()->options['accepted_file_types']) ?>)$/i,
						dataType: 'json',
						context: jQuery('#wpfa_fileupload')[0]
					}).always(function () {
			            jQuery(this).removeClass('wpfa-fileupload-processing');
			        }).done(function (result) {
						jQuery(this).fileupload('option', 'done')
						.call(this, jQuery.Event('done'), {result: result});
			        });
			    }
			});
		</script>
		<?php
		exit;
	}
	
}